﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Windows.Forms;

namespace DessinObjets
{
    public partial class DessinDObjets : Form
    {
        #region Membres
        List<Rect> rectangles = new List<Rect>();
        List<Trait> traits = new List<Trait>();
        Color couleurParDéfaut = Color.Black;
        int epaisseurParDéfaut = 1;
        #endregion
        public DessinDObjets()
        {
            InitializeComponent();
        }
        private void Objets_Paint(object sender, PaintEventArgs e)
        {
            foreach (Trait r in traits)
                r.Dessine(e.Graphics);
            foreach (Rect r in rectangles)
                r.Dessine(e.Graphics);
        }
        #region Traitement des évènements souris
        private void Objets_MouseDown(object sender, MouseEventArgs e)
        {
            Rect curRect = TrouveObjet(e.Location);
            if (e.Button == MouseButtons.Right)
            {
                #region Edition des propriétés
                if (curRect != null)
                {
                    Params par = new Params();
                    par.Epaisseur = curRect.Epaisseur;
                    par.Couleur = curRect.Couleur;
                    par.Text = curRect.Texte;
                    if (par.ShowDialog() == DialogResult.OK)
                    {
                        curRect.Epaisseur = par.Epaisseur;
                        curRect.Couleur = par.Couleur;
                        curRect.Texte = par.Texte;
                        Refresh();
                    }
                }
                #endregion
            }
            else
            {
                #region Dessin
                if (curRect == null)
                {
                    #region Ajout d'un rectangle
                    curRect = new Rect(new Rectangle(e.Location, new Size(10, 10)), couleurParDéfaut, epaisseurParDéfaut);
                    rectangles.Add(curRect);
                    Refresh();
                    #endregion
                }
                else
                {
                }
                #endregion
            }
        }
        private void Objets_MouseMove(object sender, MouseEventArgs e)
        {
        }
        private void Objets_MouseUp(object sender, MouseEventArgs e)
        {
        }
        #endregion
        /// <summary>
        /// Fonction de recherche d'un rectangle
        /// </summary>
        /// <param name="p">Point du click de souris</param>
        /// <returns>un Rect ou null</returns>
        private Rect TrouveObjet(Point p)
        {

            foreach (Rect re in rectangles)
            {
                if (re.Contains(p))
                {
                    return re;
                }
            }
            return null;
        }
        #region Modification de l'épaisseur par défaut
        private void Plus_Click(object sender, EventArgs e)
        {
            epaisseurParDéfaut += 1;
        }
        private void Moins_Click(object sender, EventArgs e)
        {
            epaisseurParDéfaut -= 1;
        }
        #endregion
    }
}
