﻿using System;
using System.Drawing;
using System.Windows.Forms;

namespace DessinObjets
{
    public partial class Params : Form
    {
        /// <summary>
        /// Texte à modifier
        /// </summary>
        public string Texte
        {
            get
            {
                return texte.Text;
            }
            set { texte.Text = value; }
        }
        /// <summary>
        /// Epaisseur renvoie la valeur du contrôle NumericUpAndDown
        /// Le transtypage est nécessaire car la valeur est décimale
        /// </summary>
        public int Epaisseur
        {
            get
            {
                return (int) epaisseur.Value;
            }
            set { epaisseur.Value = value; }
        }
        /// <summary>
        /// Couleur à modifier
        /// </summary>
        public Color Couleur
        {
            get
            {
                return couleur.BackColor;
            }
            set { couleur.BackColor = value; }
        }
        public Params()
        {
            InitializeComponent();
        }
        private void couleur_Click(object sender, EventArgs e)
        {
            ColorDialog cld = new ColorDialog();
            cld.Color = Couleur;
            if (cld.ShowDialog() == DialogResult.OK)
                Couleur = cld.Color;
        }
    }
}
