﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Text;

namespace DessinObjets
{
    /// <summary>
    /// La classe Trait représente un trait reliant deux rectangles (par leur centre), sa source et sa destination.
    /// Le trait a une épaisseur et une couleur
    /// </summary>
    public class Trait
    {
        #region Membre privés
        private Rect source;
        private Rect destination;
        private Color couleur;
        private int epaisseur;
        #endregion
        /// <summary>
        /// Création d'un trait de couleur c, d'épaisseur e, reliant
        /// les rectangles source et destination
        /// </summary>
        /// <param name="sour">Rect source</param>
        /// <param name="dest">Rect destination</param>
        /// <param name="c">couleur initiale</param>
        /// <param name="e">epaisseur initiale</param>
        public Trait(Rect sour, Rect dest, Color c, int e)
        {
            source = sour;
            destination = dest;
            couleur = c;
            epaisseur = e;
        }
        /// <summary>
        /// Dessin du trait
        /// </summary>
        /// <param name="g">Zone de dessin</param>
        public void Dessine(Graphics g)
        {
            Pen p = new Pen(couleur, epaisseur);
            g.DrawLine(p, source.Centre, destination.Centre);
        }
    }
}
